<template>
  <div class="m-20 flex justify-center">
    <div
      v-if="!userIsLoggedIn"
      class="text-2xl"
    >
      <div class="warning">
        <p class="my-10">
          {{ $t('projectAdd.notLoggedIn.warning') }}
        </p>
        <p class="my-10">
          {{ $t('projectAdd.notLoggedIn.question') }}
        </p>
          <a href="/studio">
            <button
              class="ada-button"
              type="button"
            >
              {{ $t('projectAdd.notLoggedIn.button') }}
            </button>
          </a>

        <p class="my-10">
          {{ $t('projectAdd.notLoggedIn.note.text') }}
          <router-link
            class="ada-link"
            to="/login"
          >
            {{ $t('projectAdd.notLoggedIn.note.signin') }}
          </router-link>
          {{ $t('projectAdd.notLoggedIn.note.text2') }}
          <router-link
            class="ada-link"
            to="/signup"
          >
            {{ $t('projectAdd.notLoggedIn.note.signup') }}
          </router-link>
          {{ $t('projectAdd.notLoggedIn.note.text3') }}
        </p>
      </div>
    </div>
    <div v-else>
      <div
        v-if="
          processState === 'waiting to start' ||
          processState === 'submission is refused'
        " 
      >
        <h1 class="title mb-10">
          <span v-if="thereIsASourceProject">
            {{ $t('projectAdd.loggedIn.remixExisting') }}
          </span>
          <span v-else>
            {{ $t('projectAdd.loggedIn.create') }}
          </span>
        </h1>
        <div v-if="thereIsASourceProject" class="remix">
          {{ $t('projectAdd.loggedIn.change') }}
        </div>

        <div class="w-full max-w-sm">
          <div class="md:flex md:items-center mb-6">
            <div class="md:w-1/3">
              <label
                class="ada-form-label"
                for="the-page-project-add--name"
              >
              {{ $t('projectAdd.loggedIn.label.name') }}
              </label>
            </div>
            <div class="md:w-2/3">
              <input
                v-model="name"
                @keyup.enter="submit"
                class="ada-text-input w-full"
                id="the-page-project-add--name"
                type="text"
              >
            </div>
          </div>

          <div
            v-if="!validProjectName"
            class="md:flex md:items-center mb-5 -mt-5"
          >
            <div class="md:w-1/3">
            </div>
            <div class="md:w-2/3 empty-name">
              <div>
                {{ $t('projectAdd.loggedIn.label.warning') }}
              </div>
            </div>
          </div>

          <div class="md:flex md:items-center mb-6">
            <div class="md:w-1/3">
              <label
                class="ada-form-label"
                for="the-page-project-add--description"
              >
                {{ $t('projectAdd.loggedIn.label.description') }}
              </label>
            </div>
            <div class="md:w-2/3">
              <textarea
                v-model="description"
                @keyup.enter="submit"
                class="ada-text-input w-full h-48"
                id="the-page-project-add--description"
              />
            </div>
          </div>
          <div
            v-if="validProjectName"
            class="md:flex md:items-center"
          >
            <div class="md:w-1/3"></div>
            <div class="md:w-2/3">
              <button
                class="ada-button"
                type="button"
                @click="submit"
              >
                <span v-if="thereIsASourceProject">
                  {{ $t('projectAdd.loggedIn.remix') }}
                </span>
                <span v-else>
                  {{ $t('projectAdd.loggedIn.add') }}
                </span>
              </button>
            </div>
          </div>
        </div>
        <div
          class="process-state-message"
          v-if="processState === 'submission is refused'"
        >
          <p>
            {{ $t('projectAdd.loggedIn.processStateMessage.refused.text') }}
          </p>
          <p class="mt-4">
            {{ $t('projectAdd.loggedIn.processStateMessage.refused.text2') }}
          </p>
        </div>
      </div>
      <div
        v-if="processState === 'wait for request response'"
        class="process-state-message"
      >
        {{ $t('projectAdd.loggedIn.processStateMessage.waiting') }}
      </div>
      <div
        v-if="processState === 'project submitted'"
        class="process-state-message"
      >
        {{ $t('projectAdd.loggedIn.processStateMessage.success') }}
      </div>
    </div>
  </div>
</template>

<script>
import { ref, watchEffect, computed } from 'vue'
import {
  useStore,
  useSubmitNewProjectProcess,
  useGetProjectByUid
} from '../store.js'
import router from '../router'
import { adacraftStorageUrl } from '../config'
import { v4 as uuidv4 } from 'uuid'

function projectNameIsValid(string) {
  const validProjectNameLength = /[a-zA-Z0-9-_@$*!?%#áàâäãåçéèêëíìîïñóòôöõúùûüýÿæœÁÀÂÄÃÅÇÉÈÊËÍÌÎÏÑÓÒÔÖÕÚÙÛÜÝŸÆŒ]{1,128}/gm
  return validProjectNameLength.test(string)
}

export default {
  name: 'ThePageProjectAdd',
  props: {
    sourceProjectId: String,
    sourceName: String,
    sourceDescription: String
  },
  setup (props) {
    const { currentUser, userIsLoggedIn } = useStore()

    const name = ref(props.sourceName || '')
    const description = ref(props.sourceDescription || '')

    const validProjectName = computed(() => (projectNameIsValid(name.value)))

    const sourceProject = ref({})
    const { getProjectByUid } = useGetProjectByUid()
    watchEffect(async () => {
      if (props.sourceProjectId) {
        try {
          sourceProject.value = await getProjectByUid(props.sourceProjectId)        
          if (name.value === '') {
            name.value = sourceProject.value.name
          }
          if (description.value === '') {
            description.value = sourceProject.value.abstract
          }
        } catch (error) {
            console.log(`fetching source project (${props.sourceProjectId}) error: ${error}`)
        }
      }
    })

    const thereIsASourceProject = computed(
      () => props.sourceProjectId !== undefined
    )

    const sourceStorageBaseUrl = computed(() => (
        sourceProject.value.storage
        ? sourceProject.value.storage
        : adacraftStorageUrl
    ))

    const getProjectInfo = function () {
      const uniqueId = uuidv4().substr(0, 8)
      const project = {
        name: name.value,
        id: uniqueId,
        userId: currentUser.value.id,
        userName: currentUser.value.name,
        abstract: description.value,
        // We need to use the same storage space as the source for a new
        // project, because the source project might reference some assets that
        // are also stored on that storage space.
        storage: sourceStorageBaseUrl.value
      }
      if (thereIsASourceProject.value) {
        project.forkedFromProject = props.sourceProjectId
      }
      return project
    }

    const { processState, startSubmitNewProjectProcess } = useSubmitNewProjectProcess()
    const submit = async function () {
      const project = getProjectInfo()
      const zeSourceProjectId = props.sourceProjectId || 'default'
      const projectId = await startSubmitNewProjectProcess(
        project, sourceStorageBaseUrl.value, zeSourceProjectId
      )
      if (projectId !== undefined) {
        router.push(`/project/${projectId}`)
        if (thereIsASourceProject.value) {
          window.open(
            `/studio?project=${project.id}`,
            '_self'
          )
        }

        processState.value = 'waiting to start'
      }
    }

    return {
      name,
      validProjectName,
      description,
      userIsLoggedIn,
      processState,
      thereIsASourceProject,
      submit
    }
  }
}
</script>

<style lang="postcss" scoped>
.warning {
  @apply m-10 max-w-md p-10;
  @apply shadow-2xl;
  @apply dark:shadow-gray-900;
  @apply text-xl text-gray-700;
  @apply dark:text-gray-400;
}

.title {
  @apply p-10;
  @apply text-center text-2xl;
  @apply text-gray-800;
  @apply dark:text-gray-300;
  @apply tracking-wider;
}

.remix {
  @apply m-10 max-w-sm px-8;
  @apply text-gray-600 text-center;
  @apply dark:text-gray-400;
}

.empty-name {
  @apply text-gray-600 text-center italic;
  @apply dark:text-gray-400;
}

.process-state-message {
  @apply my-10;
  @apply dark:text-gray-300;
}
</style>